#include "draw.h"


void Draw_printCenter(char* string, int y, int center)
{
	int lenght = Draw_stringLength(string);
	
	PrintMini(center - lenght/2, y, (unsigned char*)string, 0);
}


void Draw_printText(char* string, int delay, int y0)
{
	int x = 0;
	int y = y0;
	int i = 0;
	char buf[2];
	
	while(string[i] != '\0')
	{
		sprintf(buf, "%c", string[i]);
		PrintMini(x, y, (unsigned char*)buf, 0);
		
		switch(string[i])
		{
			case 'M': case 'N':
			case 'Q': case 'w':
			case 'W': case 'm':
				x+=6;
				break;
			
			case 'K': case 'n':
			case 'r':
				x += 5;
				break;
			
			case 'i':
				x += 2;
				break;
			
			case ' ':
				if(x != 0)
					x+=4;
				break;
				
			case '\t':
				PrintMini(x, y, (unsigned char*)"  ", 0);
				x+=6;
			
			default:
				x += 4;
		}
		
		if(delay)
		{
			ML_display_vram();
			Sleep(delay);
		}
		
		if(x >= 124)
		{
			x = 0;
			y += 6;
		}
		i++;
	}
	
	ML_display_vram();
}


int Draw_stringLength(char *string)
{
	int i=0;
	int x=0;
	
	while(string[i] != '\0')
	{
		switch(string[i])
		{
			case 'M': case 'N':
			case 'Q': case 'w':
			case 'W': case 'm':
				x+=6;
				break;
			
			case 'K': case 'n':
			case 'r':
				x += 5;
				break;
			
			case 'i':
				x += 2;
				break;
			
			case ' ':
				if(x != 0)
					x+=4;
				break;
				
			case '\t':
				x+=6;
			
			default:
				x += 4;
		}
		
		i++;
	}
	
	return x;
}


void setFps(int fpsWish)
{
	static unsigned int fps = 0, fps_count = 0;

	do
	{
		fps = RTC_getTicks();
		Sleep(1);
	}
	while(fps < fps_count+fpsWish);
	
	fps_count = RTC_getTicks();
}

unsigned char *Draw_zoomOr(const unsigned char *bmp, int width, int height, float zoom_w, float zoom_h)
{
    int i, j, iz, jz, width_z, height_z, nb_width, i3, bit, pixel;
    int zoom_w14, zoom_h14;
    unsigned char* newBmp = NULL;

    if (!bmp) return NULL;
    if (zoom_h < 0) zoom_h = 0;
    if (zoom_w < 0) zoom_w = 0;
    zoom_w14 = zoom_w * 16384;
    zoom_h14 = zoom_h * 16384;
    width_z = width * zoom_w14 >> 14 ;
    height_z = height * zoom_h14 >> 14;
    nb_width = width + 7 >> 3;

	newBmp = (unsigned char*)malloc(((height_z<<4)+(width_z>>3))*sizeof(unsigned char));
	if(!newBmp) return NULL;
	
    for (iz=0; iz<width_z; iz++)
    {
        i = (iz << 14) / zoom_w14;
        i3 = i >> 3;
        bit = 0x80 >> (i & 7);

        for (jz=0; jz<height_z; jz++)
        {
            j = (jz << 14) / zoom_h14;
            pixel = bmp[i3 + nb_width * j] & bit;
			if (pixel == 0) newBmp[(jz<<4)+(iz>>3)] |= 128>>(iz&7);
        }
    }
	
	return newBmp;
}











