#include "attractor.h"


Attractor::Attractor() : 
Object(1., 1., 5., color_black), m_radiusAttract(1), m_gravity(1), m_type(circle), m_orient(0)
{
	
}

Attractor::Attractor(int x, int y, TypeAttract type, float radius, int radiusAttract, int gravity, int orient) : 
Object(x, y, radius, color_black), m_radiusAttract(radiusAttract), m_gravity(gravity), m_type(type), m_orient(orient)
{
	switch(m_type)
	{
		case circle:
			break;
		case basePiaf:
			m_radius = 14.;
			m_radiusAttract = m_radius+DEFAULT_FORCE_RADIUS; // Pas de force
			m_gravity = 17;
			break;
		case basePig:
			m_radius = 34.;
			m_radiusAttract = m_radius+DEFAULT_FORCE_RADIUS;
			m_gravity = 60;
			break;
		case deathstar:
			m_radius = 6.5;
			m_radiusAttract = m_radius+DEFAULT_FORCE_RADIUS;
			m_gravity = 40;
			break;
		case spaceship:
			m_radius = 6.5;
			m_radiusAttract = m_radius+DEFAULT_FORCE_RADIUS;
			m_gravity = 30;
			break;
	}
}

Attractor::~Attractor()
{
	
}



////////////////////////////////////////// PUBLIC //////////////////////////////////////////
// 2052 octets de sprites
void Attractor::draw(int ScrMX, int ScrMY, float zoom) const
{
	const unsigned char *sprite;
	int sizeX, sizeY;
	int x=INT(m_x-ScrMX)*zoom+64;
	int y=INT(m_y-ScrMY)*zoom+32;
	
	// Trace champ de force et fond blanc
	ML_filled_circle(x, y, (int)(m_radius*zoom), color_white);
	ML_circle(x, y, (int)(m_radiusAttract*zoom), color_black);
	
	drawSimplif(ScrMX, ScrMY, zoom);

	/*
	if(m_type == circle)
	{
		ML_filled_circle(x, y, (int)(m_radius*zoom), ML_BLACK);
		return;
	}
	else if(m_type == basePiaf)
	{
		const unsigned char s[]={
			0x0, 0x7, 0xc0, 0x3, 
			0x0, 0x7f, 0xf0, 0x3, 
			0x1, 0xe0, 0xfc, 0x3, 
			0x3, 0x0, 0x7e, 0x3, 
			0x7, 0x0, 0x7f, 0x83, 
			0xe, 0x20, 0x1f, 0xc3, 
			0x18, 0x10, 0x1f, 0xe3, 
			0x30, 0x0, 0xf, 0xe3, 
			0x78, 0x0, 0x7, 0xf3, 
			0x78, 0x1, 0x7, 0xf3, 
			0x58, 0x2, 0x7, 0xfb, 
			0xc0, 0x0, 0xf, 0xfb, 
			0x80, 0x0, 0xf, 0xfb, 
			0x80, 0x40, 0xf, 0xfb, 
			0x80, 0x80, 0x1f, 0xff, 
			0x81, 0x40, 0x7f, 0x8f, 
			0x81, 0x0, 0x7f, 0xf, 
			0xc0, 0x0, 0x7e, 0xf, 
			0xc0, 0x0, 0xf8, 0xb, 
			0xc0, 0x0, 0xf0, 0x8b, 
			0x5c, 0x3, 0xf1, 0x1b, 
			0x71, 0xe7, 0xc0, 0x13, 
			0x7f, 0xff, 0xc0, 0x33, 
			0x3f, 0xff, 0x0, 0x23, 
			0x1f, 0xfe, 0x20, 0x63, 
			0x1f, 0xfc, 0x10, 0xc3, 
			0xf, 0xfc, 0x1, 0x83, 
			0x3, 0xfe, 0x7, 0x3, 
			0x1, 0xff, 0x1c, 0x3, 
			0x0, 0x7f, 0xf0, 0x3, 
			0x0, 0x7, 0x0, 0x3, 
		};
		
		sprite = s;
		
		sizeX = 30;
		sizeY = 31;
		
		x -= 14*zoom;
		y -= 15*zoom;
	}
	else if(m_type == basePig)
	{
		const unsigned char s[]={
			0x0, 0x0, 0x0, 0x7, 0xff, 0xff, 0xf0, 0x0, 0x1f, 
			0x0, 0x0, 0x0, 0xff, 0xff, 0xff, 0xf8, 0x0, 0x1f, 
			0x0, 0x0, 0x7, 0xfe, 0x0, 0x0, 0x1c, 0x0, 0x1f, 
			0x0, 0x0, 0x1f, 0xe0, 0xfb, 0xff, 0xcc, 0x0, 0x1f, 
			0x0, 0x0, 0x7f, 0xd, 0xff, 0xff, 0xec, 0x0, 0x1f, 
			0x0, 0x1, 0xf8, 0x7f, 0xe5, 0x3f, 0xec, 0x0, 0x1f, 
			0x0, 0x3, 0xe3, 0xfb, 0x9e, 0xff, 0xec, 0x0, 0x1f, 
			0x0, 0x7, 0xcf, 0xfc, 0x7c, 0xdf, 0xec, 0x0, 0x1f, 
			0x0, 0xf, 0x1f, 0xff, 0xbc, 0x3f, 0xce, 0x0, 0x1f, 
			0x0, 0x3e, 0x7f, 0xd7, 0xff, 0xaf, 0xcf, 0x80, 0x1f, 
			0x0, 0x78, 0x9b, 0xab, 0xae, 0x87, 0x63, 0xc0, 0x1f, 
			0x0, 0x73, 0xe7, 0xfd, 0xaf, 0xd7, 0xd9, 0xc0, 0x1f, 
			0x0, 0xe5, 0x3f, 0xfe, 0xb4, 0x7f, 0x5c, 0xe0, 0x1f, 
			0x1, 0xe7, 0xe7, 0xba, 0xef, 0x5a, 0xda, 0x70, 0x1f, 
			0x3, 0xde, 0x73, 0xb3, 0xba, 0xc5, 0xd7, 0xb8, 0x1f, 
			0x7, 0x9b, 0xfb, 0xab, 0x5e, 0x76, 0x35, 0x9c, 0x1f, 
			0x7, 0x3b, 0xe6, 0xfd, 0xfc, 0xed, 0x77, 0xdc, 0x1f, 
			0xf, 0x5f, 0x3e, 0x37, 0x5d, 0xe9, 0x6f, 0xce, 0x1f, 
			0xe, 0x1f, 0xb2, 0xd7, 0xeb, 0x3a, 0xb7, 0xee, 0x1f, 
			0x1c, 0xfe, 0x65, 0x34, 0x89, 0x55, 0x8d, 0xe7, 0x1f, 
			0x1c, 0x5c, 0xf5, 0x2f, 0x97, 0xf7, 0xf5, 0xf7, 0x1f, 
			0x3b, 0xfd, 0xf7, 0x21, 0x37, 0x6f, 0xf8, 0xf3, 0x9f, 
			0x3b, 0xfe, 0xff, 0xd9, 0x60, 0xe, 0x7f, 0xfb, 0x9f, 
			0x3b, 0xfd, 0xbe, 0xdd, 0x62, 0xd2, 0x12, 0xfb, 0x9f, 
			0x75, 0xdc, 0xf7, 0xd1, 0xb4, 0x4c, 0xf4, 0xf9, 0xdf, 
			0x75, 0xf4, 0xbf, 0x53, 0x7c, 0x4f, 0xdc, 0xfd, 0xdf, 
			0x76, 0xfa, 0x3f, 0x5f, 0xd7, 0xef, 0xbf, 0xed, 0xdf, 
			0x63, 0x7e, 0x27, 0xc8, 0x21, 0x47, 0x7b, 0xf4, 0xdf, 
			0x6d, 0xbe, 0xbf, 0x20, 0x8, 0xdc, 0x7b, 0xfe, 0xdf, 
			0xed, 0x1b, 0xce, 0x65, 0x0, 0x51, 0x7, 0xfa, 0xff, 
			0xed, 0xcf, 0xf0, 0xb2, 0x0, 0x7d, 0x60, 0xfe, 0xff, 
			0xe5, 0x7b, 0xb6, 0x26, 0x20, 0x9c, 0x65, 0x7e, 0xff, 
			0xef, 0xe7, 0xfd, 0xc0, 0x2, 0x3e, 0x7f, 0xbe, 0xff, 
			0xed, 0x1f, 0x91, 0x40, 0xa0, 0x53, 0x76, 0xfe, 0xff, 
			0xef, 0xef, 0xff, 0x50, 0x88, 0x17, 0xdf, 0xde, 0xff, 
			0xef, 0x78, 0xf9, 0x98, 0x0, 0x7, 0xf9, 0x3e, 0xff, 
			0xeb, 0xff, 0xfe, 0x2, 0x1a, 0x33, 0xb5, 0x1e, 0xff, 
			0xe7, 0xa9, 0x47, 0xee, 0x3a, 0xe3, 0x77, 0xbe, 0xff, 
			0x6f, 0x7d, 0x73, 0x61, 0xb0, 0x1a, 0x67, 0xde, 0xdf, 
			0x65, 0xef, 0xfd, 0x30, 0x19, 0x9, 0xbf, 0xdc, 0xdf, 
			0x75, 0x3e, 0xff, 0x95, 0x8, 0x36, 0x33, 0x7d, 0xdf, 
			0x75, 0xf2, 0xf7, 0xdc, 0x3, 0xf9, 0xa5, 0xfd, 0xdf, 
			0x73, 0xc2, 0xff, 0xdc, 0x93, 0x7e, 0xbc, 0xf9, 0xdf, 
			0x39, 0xfb, 0x99, 0xbe, 0x95, 0xff, 0xb6, 0x7b, 0x9f, 
			0x3b, 0xff, 0xdc, 0xb8, 0xf3, 0xfa, 0x2f, 0xf3, 0x9f, 
			0x39, 0xb3, 0xc7, 0xed, 0xd7, 0xbf, 0x6c, 0xf7, 0x9f, 
			0x1d, 0xff, 0xe7, 0x77, 0xf5, 0x6d, 0x7a, 0xf7, 0x1f, 
			0x1c, 0xff, 0xed, 0x7f, 0xc7, 0x7b, 0x7b, 0xe7, 0x1f, 
			0xe, 0x3f, 0xdd, 0xc6, 0x7b, 0x97, 0xe7, 0xce, 0x1f, 
			0xf, 0x7f, 0xc7, 0xff, 0xbf, 0xeb, 0xb3, 0xde, 0x1f, 
			0x7, 0x2a, 0xbf, 0xcd, 0xfb, 0xd3, 0xe, 0x9c, 0x1f, 
			0x7, 0x97, 0x9d, 0xfd, 0x5f, 0xb5, 0xbb, 0x3c, 0x1f, 
			0x3, 0xd7, 0xfb, 0xfe, 0xbe, 0xbf, 0xc7, 0x78, 0x1f, 
			0x1, 0xcf, 0xda, 0x7a, 0x67, 0x99, 0xde, 0x70, 0x1f, 
			0x0, 0xe7, 0xd9, 0xf8, 0x75, 0xbd, 0xf8, 0xe0, 0x1f, 
			0x0, 0x73, 0xf3, 0xe8, 0xee, 0xad, 0xb9, 0xc0, 0x1f, 
			0x0, 0x78, 0xf2, 0xe9, 0xbb, 0x7f, 0xc3, 0xc0, 0x1f, 
			0x0, 0x3e, 0x7f, 0xd7, 0xcb, 0xfb, 0x8f, 0x80, 0x1f, 
			0x0, 0xf, 0xdf, 0xdc, 0xdf, 0x7b, 0x1e, 0x0, 0x1f, 
			0x0, 0x7, 0xc9, 0xaf, 0xff, 0x3e, 0x7c, 0x0, 0x1f, 
			0x0, 0x3, 0xe7, 0xce, 0xfb, 0x38, 0xf8, 0x0, 0x1f, 
			0x0, 0x1, 0xf0, 0x7f, 0xef, 0xc3, 0xf0, 0x0, 0x1f, 
			0x0, 0x0, 0x7f, 0xf, 0xfc, 0x1f, 0xc0, 0x0, 0x1f, 
			0x0, 0x0, 0x1f, 0xc0, 0x0, 0xff, 0x0, 0x0, 0x1f, 
			0x0, 0x0, 0x7, 0xff, 0xff, 0xfc, 0x0, 0x0, 0x1f, 
			0x0, 0x0, 0x0, 0xff, 0xff, 0xe0, 0x0, 0x0, 0x1f, 
			0x0, 0x0, 0x0, 0x7, 0xfc, 0x0, 0x0, 0x0, 0x1f, 
		};
		
		sprite = s;
		
		sizeX = 67;
		sizeY = 67;
		
		x -= 34*zoom;
		y -= 34*zoom;
	}
	else if(m_type == deathstar)
	{
		const unsigned char s[]={
			0xf,0x80,
			0x3f,0xe0,
			0x77,0xf0,
			0x63,0xf0,
			0xf7,0xf8,
			0xff,0xf8,
			0x1f,0xc0,
			0xe0,0x38,
			0xff,0xf8,
			0x7f,0xf0,
			0x7f,0xf0,
			0x3f,0xe0,
			0xf,0x80
		};
		
		sprite = s;
		
		sizeX = 13;
		sizeY = 13;
		
		x -= 6*zoom;
		y -= 6*zoom;
	}
	else if(m_type == spaceship)
	{
		const unsigned char s[]={
			0x60,0x30,
			0xc0,0x18,
			0x87,0x8,
			0x8a,0x88,
			0x97,0x48,
			0xed,0xb8,
			0xed,0xb8,
			0x97,0x48,
			0x8a,0x88,
			0x87,0x8,
			0x80,0x8,
			0xc0,0x18,
			0x60,0x30
		};
		
		sprite = s;
		
		sizeX = 13;
		sizeY = 13;
		
		x -= 6*zoom;
		y -= 6*zoom;
	}
	
	
	ML_bmp_or_zoom(sprite, x, y, sizeX, sizeY, zoom, zoom);
	return;
	
	if(zoom==1.)
	{
		ML_bmp_or_rotate(sprite, x, y, sizeX, sizeY, m_orient);
	}
	else
	{
		drawSimplif(ScrMX, ScrMY, zoom);
	}
	*/
}



////////////////////////////////////////// GETTERS //////////////////////////////////////////

float Attractor::get_gravity() const
{
	return (float)m_gravity;
}

float Attractor::get_radiusAttract() const
{
	return (float)m_radiusAttract;
}



////////////////////////////////////////// SETTERS //////////////////////////////////////////

