#ifndef __ATTRACT_H__
#define __ATTRACT_H__
	
	extern "C"
	{
		#include <display.h>
	}
	
	#include "object.h"
	
	#define INT(x) (int)(x+.5)
	#define DEFAULT_FORCE_RADIUS	15.
	
	typedef enum {circle=0, basePiaf, basePig, deathstar, spaceship} TypeAttract;
	
	class Attractor : public Object
	{
		public:
			Attractor();
			Attractor(int x, int y, TypeAttract type, float radius=1., int m_radiusAttract=2., int gravity=1., int orient=0);
			~Attractor();
			
			void draw(int ScrMX=64, int ScrMY=32, float zoom=1.) const;
			
			float get_gravity() const;
			float get_radiusAttract() const;
		
		private:
			int m_gravity;
			int m_radiusAttract;
			
			int m_orient;
			
			TypeAttract m_type;
			
	};

#endif