#include "bow.h"

// OK
Bow::Bow() : m_x(0), m_y(0), m_orient(0)
{
	
}

// OK
Bow::Bow(int x, int y, int orient) : m_x(x), m_y(y), m_orient(orient)
{
	
}

// OK
Bow::~Bow()
{
	
}



////////////////////////////////////////// PUBLIC //////////////////////////////////////////

void Bow::draw(int ScrMX, int ScrMY, float zoom) const
{
	extern image_t assets_image_bow;
	
	if(zoom==1.)
		dimage(m_x-4-ScrMX+64, m_y-1-ScrMY+32, &assets_image_bow);
}

void Bow::shoot(Piaf *piaf, int ScrMX, int ScrMY, float zoom)
{
	Control left(KEY_LEFT, COOLDOWN_MOVE), right(KEY_RIGHT, COOLDOWN_MOVE), up(KEY_UP, COOLDOWN_MOVE), down(KEY_DOWN, COOLDOWN_MOVE);
	
	// Save Screen

	while(IsKeyDown(KEY_SHIFT))
	{
		dclear();
		// Recall save of screen
		piaf->draw(ScrMX, ScrMY, zoom);
		dupdate();
		
		if(left.test() && m_x-piaf->get_x()<5)
			piaf->set_x( (float)(piaf->get_x()-.5) );
		if(right.test() && m_x-piaf->get_x()>-5)
			piaf->set_x( (float)(piaf->get_x()+.5) );
		if(up.test() && m_y-piaf->get_y()<5)
			piaf->set_y( (float)(piaf->get_y()-.5) );
		if(down.test() && m_y-piaf->get_y()>-5)
			piaf->set_y( (float)(piaf->get_y()+.5) );
		
		piaf->set_spd(m_x-piaf->get_x(), m_y-piaf->get_y());
		
		setFps(3);
	}
}

void Bow::shoot(Piaf *piaf, Attractor *attracts, int nbAttract, int ScrMX, int ScrMY, float zoom)
{
	Control left(KEY_LEFT, COOLDOWN_MOVE), right(KEY_RIGHT, COOLDOWN_MOVE), up(KEY_UP, COOLDOWN_MOVE), down(KEY_DOWN, COOLDOWN_MOVE);
	piaf->set_spd(0, 0);
	Piaf piafC;
	
	while(IsKeyDown(KEY_SHIFT))
	{
		dclear();
		// Recall save of screen
		piafC.copy(*piaf);
		
		for(int i=0; i<30; i++)
		{
			for(int j=0; j<STEP_PATH; j++)
			{
				piafC.resetAcc();
				for(int k=0; k<nbAttract; k++)
					piafC.calculateAttract(attracts[k]);
				piafC.calculateSpd();
				piafC.calculatePos();
				
				for(int k=0; k<nbAttract; k++)
					piafC.colliAttract(&attracts[k]);
			}
			
			dpixel((INT(piafC.get_x())-ScrMX)*zoom+64, (INT(piafC.get_y())-ScrMY)*zoom+32, color_black);
		}
		
		piaf->draw(ScrMX, ScrMY, zoom);
		dupdate();
		
		if(left.test() && m_x-piaf->get_x()<5)
			piaf->set_x( (float)(piaf->get_x()-STEP_BOW) );
		if(right.test() && m_x-piaf->get_x()>-5)
			piaf->set_x( (float)(piaf->get_x()+STEP_BOW) );
		if(up.test() && m_y-piaf->get_y()<5)
			piaf->set_y( (float)(piaf->get_y()-STEP_BOW) );
		if(down.test() && m_y-piaf->get_y()>-5)
			piaf->set_y( (float)(piaf->get_y()+STEP_BOW) );
		
		piaf->set_spd(m_x-piaf->get_x(), m_y-piaf->get_y());
		
		setFps(1);
	}
}




float Bow::get_x() const
{
	return m_x;
}

float Bow::get_y() const
{
	return m_y;
}

