#include "control.h"



int IsKeyDown(int key)
{
	volatile uint8_t *adrr = keyboard_stateBuffer();

	return (adrr[key & 0x0f] & 0x1<<((key&0xf0)/16))!=0;
}

int IsKeyUp(key_t key)
{
	return !IsKeyDown(key);
}




Control::Control() : m_bind(0), m_lastDown(0), m_cooldown(10)
{
	
}

Control::Control(unsigned int bind) : m_bind(bind), m_lastDown(0), m_cooldown(10)
{
	
}

Control::Control(unsigned int bind, int cooldown) : m_bind(bind), m_lastDown(0), m_cooldown(cooldown)
{
	
}

Control::~Control()
{
	
}


bool Control::test()
{
	if(m_lastDown>0)
		m_lastDown--;
	else
	{
		if(IsKeyDown(m_bind))
		{
			m_lastDown = m_cooldown;
			return true;
		}
		m_lastDown=0;
	}
	
	return false;
}

void Control::reset_lastDown()
{
	m_lastDown = 0;
}

