#ifndef __LEVEL_H__
#define __LEVEL_H__
	
	extern "C"
	{
		#include <display.h>
		#include <keyboard.h>
		#include <clock.h>
		#include "memory.h"
		
		#include <stdio.h>
		#include <stdlib.h>
	}
	
	
	#include "bow.h"
	#include "piaf.h"
	#include "pig.h"
	#include "attractor.h"
	#include "control.h"
	#include "draw.h"
	
	#define SD		0
	#define ROOT	1
	
	#define COOLDOWN_CAMERA	0
	#define POPUP_Y			10
	
	
	class Level
	{
		public:
			Level();
			Level(char *name);
			~Level();
			
			int		load(int memory);
			void	debug(int memory) const;
			int		play(void);
			void	draw(void) const;
			void	drawOpt(void)const;
			bool	piafOut(Piaf piaf) const;
		
		private:
			int		havePiaf() const;
			void	popUp(char *string) const;
			void	popUp(char *string, unsigned int keyRequired) const;
		
			// Level elements
			char	m_name[9];
			int		m_box[4];
			int 	m_scores[3];
			int 	m_piafs[5];
			Pig 	*m_pigs;
			int 	m_nbPigs;
			Attractor *m_attracts;
			int 	m_nbAttracts;
			Bow 	m_bow;
			
			// Screen elements
			int 	m_ScrMX;
			int 	m_ScrMY;
			float 	m_zoom;
			
			// Previous lunch variables
			int 	*m_prevL_x;
			int 	*m_prevL_y;
			int 	m_lenPrevL;
	};

#endif