/****************************************************************/
/*                                                              */
/*                            Memory                            */
/*                                                              */
/*  Description: Fonctions de manipulation de la memoire        */
/*  Auteur:      LePhenixNoir                                   */
/*  Version:     3.0                                            */
/*  Date:        11.06.2014                                     */
/*  Fichier:     memory.h - Fichier d'en-tete                   */
/*                                                              */
/****************************************************************/

#ifndef __MEMORY_H__
#define __MEMORY_H__

  #include <bfile.h>
  #include <keyboard.h>
  #include <display.h>

  #define FONTCHARACTER uint16_t

  #define memory_closefile(h)       BFile_Close(h)
  #define memory_writefile(h,c,l)   BFile_Write(h,c,l)
  #define memory_readfile(h,b,s,p)  BFile_Read(h,b,s,p)
  #define memory_filesize(h)        BFile_GetFileSize(h)

  unsigned short *memory_char2font   (char *);

  void memory_seterrors      (int);
  void memory_error          (char *,char *,int);

  int  memory_createfile     (char *,int);
  int  memory_createdir      (char *);
  int  memory_openfile       (char *,enum BFile_OpenMode);
  int  memory_deletefile     (char *);

  void *memory_load          (char *);
  // int  memory_save           (char *,void *,int);

#endif
