#ifndef __MOBILE_H__
#define __MOBILE_H__
	
	extern "C"
	{
		#include <display.h>
		#include <math.h>
	}
	
	#define ABS(x) (x>0 ? x : -x)
	
	#include "object.h"
	#include "attractor.h"

	#define T_INTEG			.15
	#define STOP_MIN_SPD	0.1
	#define DEFAULT_BOUNCE_FACT	0.5
	#define STEPS_STOP	50
	
	class Mobile : public Object
	{
		public:
			Mobile();
			Mobile(int x, int y, float mass);
			Mobile(int x, int y, float mass, color_t color);
			Mobile(int x, int y, float mass, int radius, color_t color);
			~Mobile();
			
			void calculatePos(float dT=T_INTEG);
			void calculateSpd(float dT=T_INTEG);
			void calculateAttract(Attractor attractor);
			void calculateOrient();
			
			bool colliObject(Object *object, float bounceFact=DEFAULT_BOUNCE_FACT);
			bool isStop();
			
			float get_mass() const;
			float get_spd() const;
			void get_spd(float *vx, float *vy) const;
			void get_acc(float *ax, float *ay) const;
			
			void set_spd(float vx, float vy);
			void set_orient(int orient);
			void resetAcc();
			
			
		protected:
			float m_vx;
			float m_vy;
			float m_ax;
			float m_ay;
			
			int m_orient;
			
			float m_mass;
			
		private:
			float m_oldX;
			float m_oldY;
			int m_stepStop;
			
	};

#endif