#include "object.h"


Object::Object() : m_x(0.), m_y(0.), m_radius(1.), m_color(color_black)
{
	
}

Object::Object(int x, int y) : m_x((float)x), m_y((float)y), m_radius(1.), m_color(color_black)
{
	
}

Object::Object(int x, int y, color_t color) : m_x((float)x), m_y((float)y), m_radius(1.), m_color(color)
{
	
}

Object::Object(int x, int y, int radius, color_t color) : m_x((float)x), m_y((float)y), m_radius(radius), m_color(color)
{
	
}

Object::~Object()
{
	
}



////////////////////////////////////////// PUBLIC //////////////////////////////////////////

void Object::drawSimplif(int ScrMX, int ScrMY, float zoom) const
{
	int ScrOX = ScrMX-64/zoom;
	int ScrOY = ScrMY-32/zoom;
	
	ML_filled_circle((int)((m_x-ScrOX)*zoom), (int)((m_y-ScrOY)*zoom), (int)( m_radius*zoom<=1. ? 1 : m_radius*zoom), m_color);
}

void ML_filled_circle(int x, int y, int radius, color_t color)
{
	int plot_x, plot_y, d;

	if(radius < 0) return;
	plot_x = 0;
	plot_y = radius;
	d = 1 - radius;

	dline(x-plot_y, y, x+plot_y, y, color);
	while(plot_y > plot_x)
	{
		if(d < 0)
			d += 2*plot_x+3;
		else {
			d += 2*(plot_x-plot_y)+5;
			plot_y--;
			dline(x-plot_x, y+plot_y+1, x+plot_x, y+plot_y+1, color);
			dline(x-plot_x, y-plot_y-1, x+plot_x, y-plot_y-1, color);
		}
		plot_x++;
		if(plot_y >= plot_x)
		{
			dline(x-plot_y, y+plot_x, x+plot_y, y+plot_x, color);
			dline(x-plot_y, y-plot_x, x+plot_y, y-plot_x, color);
		}
	}
}

void ML_circle(int x, int y, int radius, color_t color)
{
	int plot_x, plot_y, d;

	if(radius < 0) return;
	plot_x = 0;
	plot_y = radius;
	d = 1 - radius;

	dpixel(x, y+plot_y, color);
	if(radius)
	{
		dpixel(x, y-plot_y, color);
		dpixel(x+plot_y, y, color);
		dpixel(x-plot_y, y, color);
	}
	while(plot_y > plot_x)
	{
		if(d < 0)
			d += 2*plot_x+3;
		else
		{
			d += 2*(plot_x-plot_y)+5;
			plot_y--;
		}
		plot_x++;
		if(plot_y >= plot_x)
		{
			dpixel(x+plot_x, y+plot_y, color);
			dpixel(x-plot_x, y+plot_y, color);
			dpixel(x+plot_x, y-plot_y, color);
			dpixel(x-plot_x, y-plot_y, color);
		}
		if(plot_y > plot_x)
		{
			dpixel(x+plot_y, y+plot_x, color);
			dpixel(x-plot_y, y+plot_x, color);
			dpixel(x+plot_y, y-plot_x, color);
			dpixel(x-plot_y, y-plot_x, color);
		}
	}
}


////////////////////////////////////////// GETTERS //////////////////////////////////////////

void Object::get_pos(int *x, int *y) const
{
	*x = (int)(m_x+.5);
	*y = (int)(m_y+.5);
}

void Object::get_pos(float *x, float *y) const
{
	*x = m_x;
	*y = m_y;
}

float Object::get_x() const
{
	return m_x;
}

float Object::get_y() const
{
	return m_y;
}

float Object::get_radius() const
{
	return m_radius;
}



////////////////////////////////////////// SETTERS //////////////////////////////////////////

void Object::set_x(int x)
{
	m_x = (float)x;
}

void Object::set_y(int y)
{
	m_y = (float)y;
}

void Object::set_x(float x)
{
	m_x = x;
}

void Object::set_y(float y)
{
	m_y = y;
}

void Object::set_pos(int x, int y)
{
	m_x = (float)x;
	m_y = (float)y;
}

