#include "piaf.h"


Piaf::Piaf() : 
Mobile(), m_type(luke), m_capacity(false), m_damage(0)
{
	
}

Piaf::Piaf(int x, int y, TypePiaf type) : 
Mobile(x, y, 1., color_black), m_type(type), m_capacity(false), m_damage(0)
{
	switch(m_type)
	{
		case luke:
			m_radius = 3.;
			m_mass = 1.;
			m_damage = 100;
			break;
		case al:
			m_radius = 2.;
			m_mass = 1.;
			m_damage = 100;
			break;
		case leia:
			m_radius = 2.;
			m_mass = 1.;
			m_damage = 100;
			break;
		case chewbacca:
			m_radius = 3.;
			m_mass = 1.;
			m_damage = 100;
			break;
		case hanSolo:
			m_radius = 2.;
			m_mass = 1.;
			m_damage = 100;
			break;
	}
}

Piaf::~Piaf()
{
	
}




////////////////////////////////////////// PUBLIC //////////////////////////////////////////

bool Piaf::colliAttract(Attractor *attractor)
{
	return colliObject((Object *)attractor);
}

bool Piaf::colliPig(Pig *pig)
{
	if(pig->get_life()>0)
	{
		float sauv_vx = m_vx;
		float sauv_vy = m_vy;
		
		if(colliObject((Object *)pig, BOUNCE_FACT_PIG))
		{
			pig->set_life(pig->get_life()-m_damage);
			
			if(pig->get_life()<=0)
			{
				m_vx = sauv_vx*BOUNCE_FACT_PIG/2;
				m_vy = sauv_vy*BOUNCE_FACT_PIG/2;
			}
			
			return true;
		}
	}
	
	return false;
}

// ICI BUG POUR ROTATION
// A refaire avec Gint
void Piaf::draw(int ScrMX, int ScrMY, float zoom)
{
	drawSimplif(ScrMX, ScrMY, zoom);
	/*
	const unsigned char *sprite, *mask;
	int sizeX, sizeY;
	int x=(int)(m_x+.5) - (ScrMX-64);
	int y=(int)(m_y+.5) - (ScrMY-32);
	
	calculateOrient(); 
	// m_orient = 0;
	
	if(m_type == luke)
	{
		const unsigned char s[]={
			0x18, 
			0xa4, 
			0x4a, 
			0x43, 
			0xa6, 
			0x18, 
		};
		const unsigned char m[]={
			0xe7, 
			0x43, 
			0x81, 
			0x80, 
			0x41, 
			0xe7, 
		};
		
		sprite = s;
		mask = m;
		
		sizeX = 8;
		sizeY = 6;
		
		x -= 4;
		y -= 2;
	}
	else if(m_type == al)
	{
		const unsigned char s[]={
			0x38, 0x7f, 
			0x44, 0x7f, 
			0x97, 0x7f, 
			0x84, 0xff, 
			0x47, 0x7f, 
			0x38, 0x7f, 
		};
		const unsigned char m[]={
			0xc7, 0xff, 
			0x83, 0xff, 
			0x0, 0xff, 
			0x0, 0x7f, 
			0x80, 0xff, 
			0xc7, 0xff, 
		};
		
		sprite = s;
		mask = m;
		
		sizeX = 9;
		sizeY = 6;
		
		x -= 4;
		y -= 3;
	}
	else if(m_type == leia)
	{
		const unsigned char s[]={
			0x3c, 
			0x6a, 
			0x6b, 
			0xe2, 
			0xfc, 
		};
		const unsigned char m[]={
			0xc3, 
			0x81, 
			0x80, 
			0x1, 
			0x3, 
		};
		
		sprite = s;
		mask = m;
		
		sizeX = 8;
		sizeY = 5;
		
		x -= 4;
		y -= 3;
	}
	else if(m_type == chewbacca)
	{
		const unsigned char s[]={
			0x3c, 0x7f, 
			0x46, 0x7f, 
			0x81, 0x7f, 
			0xce, 0xff, 
			0xa5, 0xff, 
			0x91, 0x7f, 
			0x4a, 0x7f, 
			0x3c, 0x7f, 
		};
		const unsigned char m[]={
			0xc3, 0xff, 
			0x81, 0xff, 
			0x0, 0xff, 
			0x0, 0x7f, 
			0x0, 0x7f, 
			0x0, 0xff, 
			0x81, 0xff, 
			0xc3, 0xff, 
		};
		
		sprite = s;
		mask = m;
		
		sizeX = 9;
		sizeY = 8;
		
		x -= 4;
		y -= 4;
	}
	else if(m_type == hanSolo)
	{
		const unsigned char s[]={
			0x38, 0x7f, 
			0x38, 0x7f, 
			0x24, 0x7f, 
			0x4b, 0x7f, 
			0x42, 0xff, 
			0x81, 0x7f, 
			0x7e, 0x7f, 
		};
		const unsigned char m[]={
			0xc7, 0xff, 
			0xc7, 0xff, 
			0xc3, 0xff, 
			0x80, 0xff, 
			0x80, 0x7f, 
			0x0, 0xff, 
			0x81, 0xff, 
		};

		sprite = s;
		mask = m;
		
		sizeX = 9;
		sizeY = 7;
		
		x -= 4;
		y -= 4;
	}
	
	if(zoom==1.)
	{
		ML_bmp_and_rotate(mask, x, y, sizeX, sizeY, m_orient);
		ML_bmp_or_rotate(sprite, x, y, sizeX, sizeY, m_orient);
	}
	else
	{
		drawSimplif(ScrMX, ScrMY, zoom);
	}
	*/
}

void Piaf::copy(Piaf piafC)
{
	float x, y;
	
	piafC.get_pos(&x, &y);
	m_x = x; m_y = y;
	piafC.get_spd(&x, &y);
	m_vx = x; m_vy = y;
	
	m_mass = piafC.get_mass();
}




////////////////////////////////////////// PRIVATE //////////////////////////////////////////



////////////////////////////////////////// GETTERS //////////////////////////////////////////

TypePiaf Piaf::get_type() const
{
	return m_type;
}

