#include "pig.h"

Pig::Pig() : Object(), m_type(soldier), m_life(100), m_orient(0)
{
	
}

Pig::Pig(int x, int y, TypePig type, int orient) : Object(x, y, color_black), m_type(type), m_life(100), m_orient(orient)
{
	switch(type)
	{
		case soldier:
			m_life = 100;
			m_radius = 5.;
			break;
		case king:
			m_life = 200;
			m_radius = 10.;
			break;
	}
}

Pig::~Pig()
{
	
}




////////////////////////////////////////// PUBLIC //////////////////////////////////////////

void Pig::draw(int ScrMX, int ScrMY, float zoom) const
{
	const unsigned char *sprite;
	int sizeX, sizeY;
	int x=(int)(m_x+.5) - (ScrMX-64);
	int y=(int)(m_y+.5) - (ScrMY-32);
	
	drawSimplif(ScrMX, ScrMY, zoom);

	/*
	if(m_type == soldier)
	{
		const unsigned char s[]={
			0xdf, 0x7f, 
			0xe0, 0xff, 
			0x51, 0x5f, 
			0x80, 0x3f, 
			0x8e, 0x3f, 
			0x91, 0x3f, 
			0x8e, 0x3f, 
			0xc0, 0x7f, 
			0x7f, 0xdf, 
		};
		
		sprite = s;
		
		sizeX = 11;
		sizeY = 9;
		
		x -= 5;
		y -= 5;
	}
	else if(m_type == king)
	{
		const unsigned char s[]={
			0x0,0x0,0x78,0x0,
			0x1c,0x0,0xcc,0x0,
			0x22,0x3e,0x84,0x0,
			0x21,0x41,0x2,0x0,
			0x4c,0x80,0x32,0x0,
			0x4c,0x0,0x34,0x0,
			0x20,0x0,0xc,0x0,
			0x18,0x0,0x8,0x0,
			0x8,0x3f,0x86,0x0,
			0x10,0x40,0x41,0x0,
			0x20,0x9b,0x20,0x80,
			0x5d,0x3b,0xae,0x40,
			0xa3,0x31,0xb1,0x40,
			0xa7,0x0,0x33,0x40,
			0xa3,0x80,0x51,0x40,
			0x9c,0x40,0x8e,0x40,
			0x80,0x3f,0x80,0x40,
			0x80,0x11,0x0,0x40,
			0x40,0xe,0x0,0x80,
			0x20,0x0,0x1,0x0,
			0x1c,0x0,0xe,0x0,
			0x3,0xc1,0xf0,0x0,
			0x0,0x3e,0x0,0x0
		};
		
		sprite = s;
		
		sizeX = 26;
		sizeY = 23;
		
		x -= 13;
		y -= 13;
	}
	
	if(m_life>0)
	{
		if(zoom==1.)
			ML_bmp_or_rotate(sprite, x, y, sizeX, sizeY, m_orient);
		else
			drawSimplif(ScrMX, ScrMY, zoom);
	}
	*/
}




////////////////////////////////////////// GETTERS //////////////////////////////////////////

int Pig::get_life() const
{
	return m_life;
}


////////////////////////////////////////// SETTERS //////////////////////////////////////////

void Pig::set_life(int newLife)
{
	m_life = newLife;
}

